;; Ergonomy/theme.jl
;; $Id$

;;   *** Ergonomy ***
;;     for Sawfish
;;
;; -> Try with "Ergonomy" theme for GTK.
;;
;; This theme is based on: 
;;   "Ergonomy" for Enlightenment;  and
;;   "Ergonomy Dreams" for Sawfish.
;;
;; By:
;;   Adrin Ferrer <aferrer@dit.upm.es>

;; This is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


(let*
    (

     (menu-i (list (make-image "gnome.png")
		   (make-image "gnome.png") (make-image "gnome-active.png")
 		   (make-image "gnome-selected.png")))
       
     (title-i (list (make-image "title-bg.png")
		    (make-image "title.png")))
       
     (clear-area (list (make-image "point.png") ))


     (wind-topleft (list (make-image "wind-topleft.png")))
       
     (wind-topright (list (make-image "wind-topright.png")))
       
     (wind-rightbottom (list (make-image "wind-rightbottom.png")))
       
     (wind-bottomleft (list (make-image "wind-bottomleft.png")))
       
     (wind-top (list (make-image "wind-top.png")))
       
     (wind-right (list (make-image "wind-right.png")))
       
     (wind-bottom (list (make-image "wind-bottom.png")))
       
     (wind-left (list (make-image "wind-left.png")))
       
       
     (max-i (list (make-image "max-bg.png")
		  (make-image "max.png") (make-image "max-active.png")
		  (make-image "max-selected.png")))
       
     (min-i (list (make-image "min-bg.png")
		  (make-image "min.png") (make-image "min-active.png")
		  (make-image "min-selected.png")))
       
     (close-i (list (make-image "close-bg.png")
		    (make-image "close.png") (make-image "close-active.png")
		    (make-image "close-selected.png")))
       
       
;***************
     (frame `(
	      ((background . ,wind-topleft)
	       (left-edge . -3)
	       (top-edge . -20)
	       (class . top-left-corner))

	      ((background . ,wind-topright)
	       (right-edge . -3)
	       (top-edge . -20)
	       (class . top-right-corner))

	      ((background . ,wind-rightbottom)
	       (right-edge . -3)
	       (bottom-edge . -3)
	       (class . bottom-right-corner))

	      ((background . ,wind-bottomleft)
	       (left-edge . -3)
	       (bottom-edge . -3)
	       (class . bottom-left-corner))

	      ((background . ,wind-top)
	       (top-edge . -20)
	       (left-edge . 5)
	       (right-edge . 5)
	       (class . top-border))

	      ((background . ,wind-right)
	       (right-edge . -3)
	       (top-edge . -12)
	       (bottom-edge . 5)
	       (class . right-border))

	      ((background . ,wind-bottom)
	       (bottom-edge . -3)
	       (left-edge . 5)
	       (right-edge . 5)
	       (class . bottom-border))

	      ((background . ,wind-left)
	       (left-edge . -3)
	       (top-edge . -12)
	       (bottom-edge . 5)
	       (class . left-border))


	      ((background . ,title-i)
	       (left-edge . 20)
	       (right-edge . 57)
	       (top-edge . -17)
	       (height . 18)
	       (foreground . "black")
	       (font . "-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1")
	       (text . ,window-name)
	       (y-justify . 2)
	       (x-justify . 0)
	       (cursor . left_ptr)
	       (class . title))

	      ;## Title left clear area
	      ((background . ,clear-area)
	       (left-edge . 0)
	       (width . 20)
	       (top-edge . -17)
	       (height . 18)
	       (cursor . left_ptr)
	       (class . title))

	      ;## Title right clear area
	      ((background . ,clear-area)
	       (right-edge . 0)
	       (width . 57)
	       (top-edge . -17)
	       (height . 18)
	       (cursor . left_ptr)
	       (class . title))

	      ((background . ,menu-i)
	       (left-edge . 2)
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (class . menu-button))

	      ((background . ,min-i)
	       (right-edge . 38)
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (class . iconify-button))

	      ((background . ,max-i)
	       (right-edge . 20)
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (class . maximize-button))

	      ((background . ,close-i)
	       (right-edge . 2)
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (class . close-button))
     ))


;*************
     (shaped-frame `(
	      ((background . ,wind-topleft)
	       (left-edge . -3)
	       (top-edge . -20)
	       (class . top-left-corner))

	      ((background . ,wind-topright)
	       (right-edge . -3)
	       (top-edge . -20)
	       (class . top-right-corner))

	      ((background . ,wind-rightbottom)
	       (right-edge . -3)
	       (top-edge . -4)
	       (class . bottom-right-corner))

	      ((background . ,wind-bottomleft)
	       (left-edge . -3)
	       (top-edge . -4)
	       (class . bottom-left-corner))

	      ((background . ,wind-top)
	       (top-edge . -20)
	       (left-edge . 5)
	       (right-edge . 5)
	       (class . top-border))

	      ((background . ,wind-right)
	       (right-edge . -3)
	       (top-edge . -12)
	       (height . 12)
	       (class . right-border))

	      ((background . ,wind-bottom)
	       (top-edge . 0)
	       (left-edge . 5)
	       (right-edge . 5)
	       (class . bottom-border))

	      ((background . ,wind-left)
	       (left-edge . -3)
	       (top-edge . -12)
	       (height . 12)
	       (class . left-border))


	      ((background . ,title-i)
	       (left-edge . 20)
	       (right-edge . 57)
	       (top-edge . -17)
	       (height . 18)
	       (foreground . "black")
	       (font . "-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1")
	       (text . ,window-name)
	       (y-justify . 2)
	       (x-justify . 0)
	       (cursor . left_ptr)
	       (class . title))

	      ;## Title left clear area
	      ((background . ,clear-area)
	       (left-edge . 0)
	       (width . 20)
	       (top-edge . -17)
	       (height . 18)
	       (cursor . left_ptr)
	       (class . title))

	      ;## Title right clear area
	      ((background . ,clear-area)
	       (right-edge . 0)
	       (width . 57)
	       (top-edge . -17)
	       (height . 18)
	       (cursor . left_ptr)
	       (class . title))

	      ((background . ,menu-i)
	       (left-edge . 2)
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (class . menu-button))

	      ((background . ,min-i)
	       (right-edge . 38)
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (class . iconify-button))

	      ((background . ,max-i)
	       (right-edge . 20)
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (class . maximize-button))

	      ((background . ,close-i)
	       (right-edge . 2)
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (class . close-button))

	))

  )

;*************
;*************
  (add-frame-style 'Ergonomy
		   (lambda (w type)
		     (cond ((eq type 'shaped)
			    shaped-frame)
		           ((eq type 'shaded)
			    shaped-frame)
			   ((eq type 'transient)
			    frame)
			   ((eq type 'shaped-transient)
			    shaped-frame)
			   ((eq type 'shaded-transient)
			    shaped-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame)
		   ) )
  )
)
